import 'package:fluid/fluid.dart';

class DistinctFlow<T> extends Flow<T> {
  final Flow<T> source;
  DistinctFlow(this.source) : super(source.value) {
    source.addListener(_onFlowUpdate);
  }

  void _onFlowUpdate() {
    if (value == source.value) {
      return;
    } else {
      emit(source.value);
    }
  }

  @override
  void dispose() {
    source.removeListener(_onFlowUpdate);
    super.dispose();
  }
}
