import 'package:fluid/fluid.dart';

typedef FlowMapper<T, T2> = T2 Function(T value);

class MappingFlow<T, T2> extends Flow<T2> {
  final Flow<T> source;
  final FlowMapper<T, T2> mapper;

  @override
  T2 get value => mapper(source.value);

  MappingFlow(
    this.source,
    this.mapper,
  ) : super(mapper(source.value)) {
    source.addListener(_onUpdate);
  }

  @override
  void dispose() {
    super.dispose();
    source.removeListener(_onUpdate);
    source.dispose();
  }

  void _onUpdate() {
    final transformedValue = mapper(source.value);
    emit(transformedValue);
  }
}
