abstract class FluidContainer {
  T getInstance<T>();
}

class SimpleFluidContainer extends FluidContainer {
  final Map<Type, dynamic> instances = {};
  @override
  T getInstance<T>() {
    if (instances.containsKey(T)) {
      return instances[T] as T;
    } else {
      throw ArgumentError("Type $T is not registered");
    }
  }

  void registerType<T>(T instance) {
    instances[T] = instance;
  }
}
