import 'package:fluid/fluid.dart';
import 'package:flutter/widgets.dart';

class FluidResolver extends InheritedWidget {
  final FluidContainer container;

  const FluidResolver({
    required this.container,
    required Widget child,
    Key? key,
  }) : super(
          child: child,
          key: key,
        );

  T getFluid<T extends Fluid>(FluidFactory<T> fluidFactory) {
    return fluidFactory.createFluid(container);
  }

  static FluidResolver of(BuildContext buildContext) {
    final resolver =
        buildContext.dependOnInheritedWidgetOfExactType<FluidResolver>();

    if (resolver == null) {
      throw FlutterError("No FluidResolver found in context");
    }

    return resolver;
  }

  @override
  bool updateShouldNotify(covariant InheritedWidget oldWidget) {
    if (oldWidget is FluidResolver) {
      return oldWidget.container != container;
    } else {
      return true;
    }
  }
}
